parser grammar KrakatoaParser;
options {tokenVocab = JavaLexer;
         contextSuperClass=org.antlr.v4.runtime.RuleContextWithAltNum;}
import JavaParser, SpecificationParser;

@parser::members {
    public int specLevel = 0;
}

langExpr : expression;
langId : javaIdentifier;
langType : typeType;
langModifier : classOrInterfaceModifier;
langStatement : blockStatement;
langDecl : modifier* memberDeclaration;

startSpec
    : LineStartOptionSpec {specLevel++;}
    | LineStartSpec {specLevel++;}
    | BlockStartSpecImmediate {specLevel++;}
    ;

endSpec
    : EndSpec {specLevel--;}
    | LineCommentStartInSpec {specLevel--;}
    ;