package krakatoa

import generated.{KrakatoaParser, KrakatoaParserBaseListener}

class TestListenerImpl extends KrakatoaParserBaseListener {

  override def enterClassDeclaration(ctx: KrakatoaParser.ClassDeclarationContext): Unit = {
    val className = ctx.javaIdentifier().getText()
    println("I've found a class called: "+className)
  }

  override def enterKrakatoaOption(ctx: KrakatoaParser.KrakatoaOptionContext): Unit = {
    println("Found a Krakatoa option: " + ctx.KRAKATOA_PROPERTY().getText)
  }

}
