package generic.syntaxTree
import generic.SourceLocation

trait StringNode extends TreeNode {
  var text: String

  override def stringRepresentation: String = text
}
case class ConstantStringNode (var text: String,
                               var precedingWhitespace: String="") extends StringNode {
  var srcLocation: SourceLocation = SourceLocation("", -1)
  override val nodeType: NodeType = NodeType.ANY
}
