package languages

import intermediateRepresentation.IRProgram

trait IProgram {
  def toText: String
  def toIRProgram: IRProgram

}

trait IProgramGenerator[A] {
  def fromText(contents: String) : A
  def fromFile(filename: String): A
  def fromIRProgram(irProgram: IRProgram) : A

}
