// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case IncrSilicon
//:: tools silicon
//:: verdict Pass Incr.incr_n_ok Incr.incr_ok

 /*@ nullable_by_default */ class Incr {
   /*@ spec_public */ int val;
  
  /*@ 
    // cannot express permission amount exactly. commented out
//  
//  /*  
//    requires IR_permission_expression(val, 1);
    ensures val == \old(val)+1;
   */
    //@ assignable val;

   /*@ spec_public */ void incr_ok()
  {
    val = val+1;
  }

  /*@ 
    requires  n>=0;
    ensures val == \old(val)+n; 
   */
    //@ assignable val;

   /*@ spec_public */ void incr_n_ok(int n)
  {
    int tmp;
    tmp=n;
    /*@ 
      // cannot express permission amount exactly. commented out 
//      loop_invariant IR_permission_expression(val, 1);
      loop_invariant val+tmp == \old(val)+n && tmp>=0;
      loop_modifies val; 
	 */
    while(tmp>0)
    {
      val=val+1;
      tmp=tmp-1;
    }
  }

}

