package basic;
// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: cases Counter
//:: tools silicon
//:: verdict Pass
/*
check with vct --silicon Counter.java
*/
class Counter {
  private int val;

  void incr(){
    val = val+1;
  }
  
  void incr_by_n(int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      val=val+1;
      tmp=tmp-1;
    }
  }

  static void incr_static(Counter c,int n)
  {
    int tmp=n;
    while(tmp>0)
    {
      c.incr();
      tmp=tmp-1;
    }
  }

  static void main(){
    Counter c=new Counter();
    assert c.val==0;
  }
}
