package basic;

class CounterTester {
  private static Counter c = new Counter();
  private static java.util.Random rnd = new java.util.Random(1000);

  public static void renew() {
    c = new Counter();
  }

  public static void incr() {
    c.incr();
  }
  
  public static void incr_by_n() {
    c.incr_by_n(rnd.nextInt(1000));
  }
  
  public static void incr_static_tester() {
    Counter.incr_static(c, rnd.nextInt(1000));
  }
  
  public static void incr_by_0() {
    c.incr_by_n(0);
    c.incr_by_n(0);
    c.incr_by_n(0);
  }

  public static void main(String[] args) {
    int max = rnd.nextInt(500);
    for(int i=0; i<max; ++i) {
      switch(rnd.nextInt(5)) {
        case 0: renew();
        case 1: incr();
        case 2: incr_by_n();
        case 3: incr_by_0();
        case 4: incr_static_tester();
      }
    }
  }

}