# Specification Translator: Tool to Translate Specifications for Deductive Verifiers

This tool has been implemented as part of our research titled "Join Forces! Reusing Contracts for Deductive Verifiers through Automatic Translation". 
This tool will translate specifications in verified Java programs from one specification language into another. It supports the tools Krakatoa, OpenJML and VerCors. 

The tool takes an annotated Java program and a target tool as input. It will then generate an annotated Java program where the annotations have been translated.
The tool can be used by executing the following command in the terminal: "java -jar AnnotationTranslator.jar -s  [source-tool] -t [target-tool] [filename]". This requires at least Java 11. 


The implementation of the tool can be found in the AnnotationTranslator/ directory.
Examples and scripts that were used for the evaluation can be found in the Evaluation/ directory.