package parserScala

import generated.vercors.{JavaParser, JavaParserBaseListener}

class TestListenerImpl extends JavaParserBaseListener {

  override def enterClassDeclaration(ctx: JavaParser.ClassDeclarationContext): Unit = {
    val className = ctx.javaIdentifier().getText()
    println("I've found a class called: "+className)
  }

  override def enterCompilationUnit(ctx: JavaParser.CompilationUnitContext): Unit = {
    enterClassDeclaration(ctx.typeDeclaration(0).classDeclaration())
  }

}
