package generic


class NotSupportedException(_construct: String,
                            sourceLocation: SourceLocation)
      extends Exception {
  override def getMessage: String = {
    s"[WARNING]   Translating ${construct} (found${sourceLocation.toString}) is not yet supported. "
      + s"It will be turned into a comment."
  }

  def construct: String = _construct
}
